import {
  Annotation,
  Decorator,
} from '@overflow/commons/core/reflect';

import {
  PropertyKeyType,
  TypeUtil,
} from '@overflow/commons/core/type';

export interface PostConstructAnnotationAttributes {
  name?: string[];
}

export class PostConstructAnnotation extends Annotation {
  public readonly attributes: PostConstructAnnotationAttributes = {

  };

  public constructor(name: string | string[] | PostConstructAnnotationAttributes) {
    super();
    if (undefined === name) {
      return;
    }

    if (TypeUtil.isString(name)) {
      this.attributes.name = [<string>name];
    } else {
      this.copyAttributes(this.attributes, <PostConstructAnnotationAttributes>name);
    }
  }

  public methodDecorator<T>(target: Object, propertyKey: PropertyKeyType,
                            descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void {
    console.log('PostConstruct');
  }

}

export const PostConstruct = Decorator.create(PostConstructAnnotation);
