import { PropertyKeyType } from '@overflow/commons/core/type';

import { PropertyValue } from './property_value';



export class MutablePropertyValues {
  private propertyValueList: PropertyValue[];
  private processedProperties: Set<PropertyKeyType>;

  public constructor(propertyValueList?: PropertyValue[]) {
    if (undefined === propertyValueList) {
      this.propertyValueList = [];
    } else {
      this.propertyValueList = propertyValueList;
    }
  }

  public addPropertyValue(pv :PropertyValue): MutablePropertyValues {
		for (let i = 0; i < this.propertyValueList.length; i++) {
			let currentPv: PropertyValue = this.propertyValueList[i];
			if (currentPv.Name === pv.Name) {
				pv = mergeIfRequired(pv, currentPv);
				setPropertyValueAt(pv, i);
				return this;
			}
		}
		this.propertyValueList.push(pv);
		return this;
  }
}