import {
  Annotation,
  Decorator,
} from '@overflow/commons/core/reflect';

import {
  PropertyKeyType,
  TypeUtil,
} from '@overflow/commons/core/type';

export interface RestAPIAnnotationAttributes {
  entryPath: string;
}

export class RestAPIAnnotation extends Annotation {
  public readonly attributes: RestAPIAnnotationAttributes = {
    entryPath: undefined,
  };

  public constructor(entryPath: string | RestAPIAnnotationAttributes) {
    super();
    if (undefined === entryPath) {
      throw new Error(`entryPath attribute must be specified.`);
    }

    if (TypeUtil.isString(entryPath)) {
      this.attributes.entryPath = <string>entryPath;
    } else {
      this.copyAttributes(this.attributes, <RestAPIAnnotationAttributes>entryPath);
    }
  }

  public methodDecorator<T>(target: Object, propertyKey: PropertyKeyType,
                            descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void {
    console.log('RestAPI');
  }
}

export const RestAPI = Decorator.create(RestAPIAnnotation);
