import {
  Annotation,
  Decorator,
} from '@overflow/commons/core/reflect';

import {
  PropertyKeyType,
  TypeUtil,
} from '@overflow/commons/core/type';

export interface RpcAPIAnnotationAttributes {
  method: string;
}

export class RpcAPIAnnotation extends Annotation {
  public readonly attributes: RpcAPIAnnotationAttributes = {
    method: undefined,
  };

  public constructor(method: string | RpcAPIAnnotationAttributes) {
    super();
    if (undefined === method) {
      throw new Error(`method attribute must be specified.`);
    }

    if (TypeUtil.isString(method)) {
      this.attributes.method = <string>method;
    } else {
      this.copyAttributes(this.attributes, <RpcAPIAnnotationAttributes>method);
    }
  }

  public methodDecorator<T>(target: Object, propertyKey: PropertyKeyType,
                            descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void {
    console.log('RestAPI');
  }
}

export const RpcAPI = Decorator.create(RpcAPIAnnotation);
