import {
  Configuration,
  Instance,
} from '@overflow/commons/application/decorators';
import { Value } from '@overflow/commons/di/decorators';
import {
  createHashHistory,
  History,
} from 'history';

@Configuration()
export class WebAppConfiguration {
  @Value('html.container.id')
  private htmlContainerID: string;

  /**
   * containerPromise
   */
  @Instance()
  public containerPromise(): Promise<HTMLElement> {
    function getContainer(containerID: string): Promise<HTMLElement> {
      return new Promise<HTMLElement>(resolve => {
        document.addEventListener('DOMContentLoaded', () => {
          resolve(document.getElementById(containerID));
        });
      });
    }

    return getContainer(this.htmlContainerID);
  }

  /**
   * history
   */
  @Instance()
  public history(): History {
    return createHashHistory();
  }

}
